From: Florian Westphal <fw@strlen.de>
To: <netfilter-devel@vger.kernel.org>
Cc: Florian Westphal <fw@strlen.de>
Subject: [PATCH nft v2 11/11] tests: add typeof test cases
Date: Fri, 13 Dec 2019 17:03:45 +0100 [thread overview]
Message-ID: <20191213160345.30057-12-fw@strlen.de> (raw)
In-Reply-To: <20191213160345.30057-1-fw@strlen.de>
Signed-off-by: Florian Westphal <fw@strlen.de>
---
.../testcases/maps/dumps/typeof_maps_0.nft | 16 ++++++++
tests/shell/testcases/maps/typeof_maps_0 | 26 ++++++++++++
.../testcases/sets/dumps/typeof_sets_0.nft | 31 ++++++++++++++
tests/shell/testcases/sets/typeof_sets_0 | 40 +++++++++++++++++++
4 files changed, 113 insertions(+)
create mode 100644 tests/shell/testcases/maps/dumps/typeof_maps_0.nft
create mode 100755 tests/shell/testcases/maps/typeof_maps_0
create mode 100644 tests/shell/testcases/sets/dumps/typeof_sets_0.nft
create mode 100755 tests/shell/testcases/sets/typeof_sets_0
diff --git a/tests/shell/testcases/maps/dumps/typeof_maps_0.nft b/tests/shell/testcases/maps/dumps/typeof_maps_0.nft
new file mode 100644
index 000000000000..5c6a4d1f8662
--- /dev/null
+++ b/tests/shell/testcases/maps/dumps/typeof_maps_0.nft
@@ -0,0 +1,16 @@
+table inet t {
+ map m1 {
+ typeof osf name : ct mark
+ elements = { "Linux" : 0x00000001 }
+ }
+
+ map m2 {
+ type string,128 : mark
+ elements = { "Linux" : 0x00000001 }
+ }
+
+ chain c {
+ ct mark set osf name map @m1
+ ct mark set osf name map @m2
+ }
+}
diff --git a/tests/shell/testcases/maps/typeof_maps_0 b/tests/shell/testcases/maps/typeof_maps_0
new file mode 100755
index 000000000000..16b54b7adeb3
--- /dev/null
+++ b/tests/shell/testcases/maps/typeof_maps_0
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+# support for strings/typeof in named maps.
+# m1 and m2 are identical, they just use different
+# ways for declaration.
+
+EXPECTED="table inet t {
+ map m1 {
+ typeof osf name : ct mark
+ elements = { \"Linux\" : 0x1 }
+ }
+
+ map m2 {
+ type string, 128 : mark
+ elements = { \"Linux\" : 0x1 }
+ }
+
+ chain c {
+ ct mark set osf name map @m1
+ ct mark set osf name map @m2
+ }
+}"
+
+set -e
+$NFT -f - <<< $EXPECTED
+
diff --git a/tests/shell/testcases/sets/dumps/typeof_sets_0.nft b/tests/shell/testcases/sets/dumps/typeof_sets_0.nft
new file mode 100644
index 000000000000..eeeeb844e0e1
--- /dev/null
+++ b/tests/shell/testcases/sets/dumps/typeof_sets_0.nft
@@ -0,0 +1,31 @@
+table inet t {
+ set s1 {
+ typeof osf name
+ elements = { "Linux" }
+ }
+
+ set s2 {
+ type string,128
+ elements = { "Linux" }
+ }
+
+ set s3 {
+ typeof vlan id
+ elements = { 2, 3, 103 }
+ }
+
+ set s4 {
+ type integer,16
+ elements = { 2, 3, 103, 2003 }
+ }
+
+ chain c1 {
+ osf name @s1 accept
+ osf name @s2 accept
+ }
+
+ chain c2 {
+ vlan id @s3 accept
+ vlan id @s4 accept
+ }
+}
diff --git a/tests/shell/testcases/sets/typeof_sets_0 b/tests/shell/testcases/sets/typeof_sets_0
new file mode 100755
index 000000000000..bbdeb4743ee7
--- /dev/null
+++ b/tests/shell/testcases/sets/typeof_sets_0
@@ -0,0 +1,40 @@
+#!/bin/bash
+
+# support for strings/typeof in named sets.
+# s1 and s2 are identical, they just use different
+# ways for declaration.
+
+EXPECTED="table inet t {
+ set s1 {
+ typeof osf name
+ elements = { \"Linux\" }
+ }
+
+ set s2 {
+ type string, 128
+ elements = { \"Linux\" }
+ }
+
+ set s3 {
+ typeof vlan id
+ elements = { 2, 3, 103 }
+ }
+
+ set s4 {
+ type integer,16
+ elements = { 2, 3, 103, 2003 }
+ }
+ chain c1 {
+ osf name @s1 accept
+ osf name @s2 accept
+ }
+
+ chain c2 {
+ ether type vlan vlan id @s3 accept
+ ether type vlan vlan id @s4 accept
+ }
+}"
+
+set -e
+$NFT -f - <<< $EXPECTED
+
--
2.23.0
prev parent reply other threads:[~2019-12-13 20:38 UTC|newest]
Thread overview: 12+ messages / expand[flat|nested] mbox.gz Atom feed top
2019-12-13 16:03 [PATCH nft v2 00/10] add typeof keyword Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 01/11] parser: add a helper for concat expression handling Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 02/11] libnftnl: split nft_ctx_new/free Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 03/11] src: store expr, not dtype to track data in sets Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 04/11] src: parser: add syntax to provide size of variable-sized data types Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 05/11] parser: add typeof keyword for declarations Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 06/11] src: add "typeof" print support Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 07/11] mnl: round up the map data size too Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 08/11] src: netlink: remove assertion Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 09/11] evaluate: print a hint about 'type,width' syntax on 0 keylen Florian Westphal
2019-12-13 16:03 ` [PATCH nft v2 10/11] doc: mention 'typeof' as alternative to 'type' keyword Florian Westphal
2019-12-13 16:03 ` Florian Westphal [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20191213160345.30057-12-fw@strlen.de \
--to=fw@strlen.de \
--cc=netfilter-devel@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox